# Extras for `LinearAlgebraX`

## Projective planes

The file `projective.jl` contains code for creating structures related 
to finite projective planes of prime order. See also [RationalProjectivePlane](https://github.com/scheinerman/RationalProjectivePlane.jl).

* `generate_points(p)` generates a list of the homogeneous coordinates of the 
points (lines) of a finite projective plane of prime order `p`.
* `incidence_matrix(p)` generates the point-line incidence matrix of a 
projective plane of order `p`.
* `incidence_graph(p)` generates the bipartite point-line incidence graph 
of a finite projective plane of order `p`.
* `incidence_hypergraph(p)` generates a hypergraph whose vertices are the 
points of an order-`p` projective plane and whose hyperedges are the lines 
of that plane. 
```
julia> include("extras/projective.jl")
incidence_graph

julia> A = incidence_matrix(3)
13×13 Array{Int64,2}:
 0  0  0  0  0  0  0  0  0  1  1  1  1
 0  0  1  0  0  1  0  0  1  0  0  0  1
 0  1  0  0  1  0  0  1  0  0  0  0  1
 0  0  0  0  0  0  1  1  1  1  0  0  0
 0  0  1  0  1  0  1  0  0  0  0  1  0
 0  1  0  0  0  1  1  0  0  0  1  0  0
 0  0  0  1  1  1  0  0  0  1  0  0  0
 0  0  1  1  0  0  0  1  0  0  1  0  0
 0  1  0  1  0  0  0  0  1  0  0  1  0
 1  0  0  1  0  0  1  0  0  0  0  0  1
 1  0  0  0  0  1  0  1  0  0  0  1  0
 1  0  0  0  1  0  0  0  1  0  1  0  0
 1  1  1  0  0  0  0  0  0  1  0  0  0
 
julia> incidence_graph(3)
SimpleGraph{Int64} (n=26, m=52)

julia> H = incidence_hypergraph(3)
SimpleHypergraph{HVector{Mod{3}}} (n=13, m=13)
 ```

## Hilbert matrices

The file `hilbert.jl` contains code to generate Hilbert matrices.
```
julia> hilbert(4)
4×4 Array{Rational{Int64},2}:
 1//1  1//2  1//3  1//4
 1//2  1//3  1//4  1//5
 1//3  1//4  1//5  1//6
 1//4  1//5  1//6  1//7

julia> detx(ans)
1//6048000
 ```

export rrefx

"""
    rrefx(A::AbstractMatrix{T}) where {T<:IntegerX}

`rref(A)`  returns the row-reduced echelon form of the exact 
matrix `A`.
"""
function rrefx(A::AbstractMatrix{T}) where {T<:Union{RationalX,IntegerX}}
    AA = big.(A // 1)
    return rrefx!(AA)
end

function rrefx(A::AbstractMatrix{T}) where {T}
    AA = copy(A)
    rrefx!(AA)
    return AA
end


function _pivot!(A::AbstractMatrix{T}, i::Int, j::Int) where {T}
    r, c = size(A)
    s = A[i, j]
    row_scale!(A, i, invx(s))

    for k = 1:r
        if k != i
            s = -A[k, j]
            row_add_mult!(A, i, s, k)
        end
    end
end



function rrefx!(A::AbstractMatrix{T}) where {T}
    rn, nc = size(A)

    r = 1
    for j = 1:nc
        # see if column j's first one is at level r or below
        col = A[r:end, j]
        if all(col .== 0)
            continue
        end
        k = findfirst(col .!= 0)
        row_swap!(A, r, k + r - 1)
        _pivot!(A, r, j)
        r += 1
    end
    return A

end

"""
`hilbert(n)` creates an `n`-by-`n` Hilbert matrix.

## Example
```
julia> hilbert(4)
4×4 Array{Rational{Int64},2}:
 1//1  1//2  1//3  1//4
 1//2  1//3  1//4  1//5
 1//3  1//4  1//5  1//6
 1//4  1//5  1//6  1//7
```
"""
function hilbert(n::Int)
    A = zeros(Rational{Int}, n, n)
    for i = 1:n
        for j = 1:n
            A[i, j] = 1 // (i + j - 1)
        end
    end
    return A
end

export rankx

"""
    rankx(A::AbstractMatrix{T})::Int where {T}

`rankx(A)` computes the rank of the exact matrix `A`
"""
function rankx(A::AbstractMatrix{T})::Int where {T}
    r, c = size(A)
    return c - nullityx(A)
end

module LinearAlgebraX
using LinearAlgebra, SimplePolynomials, Mods


# IntegerX is any sort of real or Gaussian integer
IntegerX = Union{S,Complex{S}} where {S<:Integer}

# RationalX is a Rational or Complex Rational based on integers
RationalX = Union{Rational{S},Complex{Rational{S}}} where {S<:Integer}

TypeX = Union{IntegerX,RationalX,AbstractMod}


function _recip(x::T) where {T<:IntegerX}
    return 1 // x
end
_recip(x) = inv(x)

include("row_ops.jl")
include("detx.jl")
include("cofactor_det.jl")
include("eye.jl")
include("rrefx.jl")
include("invx.jl")
include("rankx.jl")
include("nullspacex.jl")
include("char_poly.jl")
include("homogeneous.jl")
include("perm.jl")
# include("mod_smith_normal_form.jl")
# include("mod_triangular.jl")

end # module

export eye

"""
    eye(T, n)::Matrix

`eye(T,n)` returns an `n`-by-`n` identity matrix whose entries
are numbers of type `T`.

`eye(n)` is the same as `eye(Float64,n)`.
"""
function eye(T, n)::Matrix
    return Matrix{T}(I, n, n)
end

eye(n) = eye(Float64, n)

# Elementary row operations

export row_swap!, row_scale!, row_add_mult!


"""
    row_swap!(A::AbstractMatrix{T}, i::Int, j::Int) where {T}

`row_swap!(A,i,j)` swaps rows `i` and `j` in the matrix `A`.
"""
function row_swap!(A::AbstractMatrix{T}, i::Int, j::Int) where {T}
    r, c = size(A)
    @assert (1 <= i <= r) && (1 <= j <= r) "Row index out of bounds"
    if i == j
        return
    end

    save_row = [A[i, k] for k = 1:c]

    for k = 1:c
        @inbounds A[i, k] = A[j, k]
    end

    for k = 1:c
        @inbounds A[j, k] = save_row[k]
    end
end

"""
    row_scale!(A::AbstractMatrix{T}, i::Int, s) where {T}

`row_scale!(A,i,s)` multiplies all entries in row `i`
of `A` by `s`.
"""
function row_scale!(A::AbstractMatrix{T}, i::Int, s) where {T}
    r, c = size(A)
    @assert 1 <= i <= r "Row index out of bounds"

    for k = 1:c
        @inbounds A[i, k] = s * A[i, k]
    end
end


"""
    row_add_mult!(A::AbstractMatrix{T}, i::Int, s, j::Int) where {T}

`row_add_mult!(A,i,s,j)` adds `s` times row `i` to row `j`
in the matrix `A`.
"""
function row_add_mult!(A::AbstractMatrix{T}, i::Int, s, j::Int) where {T}
    r, c = size(A)
    @assert (1 <= i <= r) && (1 <= j <= r) "Row index out of bounds"

    save_row = [s * A[i, k] for k = 1:c]
    for k = 1:c
        @inbounds A[j, k] = A[j, k] + save_row[k]
    end
end

export detx

cofactor_warning = "Using cofactor expansion to calculate determinant; may be very slow."

"""
    detx(A::AbstractMatrix{T}) where {T<:IntegerX}

`detx(A::AbstractMatrix{T})` is an exact determinant of the matrix.
Here `T` can be any kind of integer, rational, or `Mod`.
"""
function detx(A::AbstractMatrix{T}) where {T<:Union{IntegerX,RationalX}}
    A = big.(A)
    TT = typeof(A[1, 1])
    return TT(det(A // 1))
end

function detx(A::AbstractMatrix{T})::T where {T<:Mod}
    try
        return det(A)
    catch
        @info cofactor_warning
        return cofactor_det(A)
    end

end

# Everything else
function detx(A::AbstractMatrix{T})::T where {T}
    B = collect(A)
    try
        return detx!(B)
    catch
        @info cofactor_warning
        return cofactor_det(B)  # if all else fails!
    end
end


# detx! is the work behind det when we can't use Julia's det.
# it can modify the matrix so this is not exposed to the general public.

function detx!(A::AbstractMatrix{T})::T where {T}
    r = LinearAlgebra.checksquare(A)

    if r == 0
        return one(T)
    end

    if r == 1
        return A[1, 1]
    end

    if r == 2
        return A[1, 1] * A[2, 2] - A[1, 2] * A[2, 1]
    end

    col = A[:, 1]  # first column
    if all(col .== 0)
        return zero(T)
    end

    k = findfirst(col .!= 0)  # we pivot here

    sign_factor = one(Int8)
    if k > 1
        sign_factor = -sign_factor
        row_swap!(A, 1, k)
    end

    factor = A[1, 1] * sign_factor  # multiply by this at the end

    row_scale!(A, 1, 1 // A[1, 1])

    for i = 2:r
        row_add_mult!(A, 1, -A[i, 1], i)
    end


    return detx!(A[2:end, 2:end]) * factor

end

function detx!(A::AbstractMatrix{<:Mod})
    U, row_ops = upper_triangular!(A)
    det_C = prod(detx(op) for op in row_ops)

    # U = C * A
    return inv(det_C) * prod(diag(U))
end

using Test
using LinearAlgebra, LinearAlgebraX, Mods


@testset "Basics" begin
    A = big.(rand(Int, 10, 10) .% 100)

    include("../extras/hilbert.jl")

    H = hilbert(12)
    @test rankx(H) == 12

    @test detx(A) == det(Rational.(A))
    @test detx(A) == detx(A')
    @test A * invx(A) == eye(BigInt, 10)

    A = ones(Int, 3, 5)
    N = nullspacex(A)
    @test all(0 .== A * N)
end

@testset "Polynomials" begin
    using SimplePolynomials

    A = triu(ones(Int, 5, 5))
    p = char_poly(A)
    x = getx()
    @test p == (x - 1)^5

    A = ones(Int, 5, 5)
    p = char_poly(A)
    @test p == x^4 * (x - 5)
end

@testset "Modular" begin
    T = Mod{17}
    A = rand(T, 6, 6)
    p = char_poly(A)
    @test detx(A) == p(0)


    A = rand(Int, 20, 20) .% 100
    @test rankx(A) <= 20
end

@testset "Complex" begin
    A = rand(Int, 5, 5) .% 100
    B = rand(Int, 5, 5) .% 100
    M = A + im * B
    @test detx(M) == cofactor_det(M)

    @test detx(M') == conj(detx(M))


    MM = invx(M)
    @test M * MM == eye(Complex{BigInt}, 5)

    @test permanent(M') == permanent(M)'
end


@testset "Homogeneous" begin
    v = HVector(2, 3, 2)
    @test v[2] == 3 // 2
    @test dot(v, v) == 1
    w = HVector(20, 30, 20)
    @test v == w

    A = rand(Int, 3, 3) .% 20
    w = A * v
    @test w == HVector(A * v.data)
end

@testset "Permanent" begin
    A = ones(Int, 6, 6)
    @test permanent(A) == factorial(6)

    A = A - eye(Int, 6)
    @test permanent(A) == 265  # number of derangements of [6]

    A = triu(ones(5, 5))
    @test permanent(A) == 1
end

# @testset "Smith Normal Form" begin
#     A = rand(Mod{30}, 5, 5)
#     S, U, V = smith_normal_form(A)
#     @test S == U * A * V
#     @test isdiag(S)
#     @test all(LinearAlgebraX.divisible(S[i,i], S[i+1,i+1]) for i in 1:4)

#     B = rand(Mod{30}, 3, 3)
#     det_B = B[1,1]*B[2,2]*B[3,3] + B[1,2]*B[2,3]*B[3,1] + B[1,3]*B[2,1]*B[3,2] -
#             B[1,3]*B[2,2]*B[3,1] - B[1,1]*B[2,3]*B[3,2] - B[1,2]*B[2,1]*B[3,3]
#     smith_normal_form(B)
#     @test det_B == detx(B)
# end

# @testset "Triangular" begin
#     function det_lower_triangular(A::AbstractMatrix{T}) where {T<:AbstractMod}
#         L, col_ops = LinearAlgebraX.lower_triangular!(copy(A))
#         det_C = prod(detx(op) for op in col_ops)
#         # L = A * C
#         return prod(diag(L)) * inv(det_C)
#     end

#     A = rand(Mod{30}, 5, 5)
#     @test detx(A) == det_lower_triangular(A)
#     U, C = upper_triangular(A)
#     @test U == C * A
#     L, D = lower_triangular(A)
#     @test L == A * D
# end

export nullspacex

"""
`nullspacex(A)` returns an exact basis for the nullspace of the matrix `A`
"""
nullspacex(A::AbstractMatrix{T}) where {T} = _nullspacex(A)


function _nullspacex(A::AbstractMatrix{T}) where {T}
    r, c = size(A)
    B = rrefx(A)

    leads = Int[]
    # in each row, find first 1
    for i = 1:r
        row = B[i, :]
        if all(row .== 0)
            continue
        end
        k = findfirst(row .!= 0)
        append!(leads, k)
    end

    frees = setdiff(collect(1:c), leads)


    result = Matrix{T}(undef, c, 0)
    for f in frees
        v = zeros(T, c)
        v[f] = T(1)
        for i = 1:length(leads)
            l = leads[i]  # (i,l) is a leading 1
            if l < f
                v[l] = -B[i, f]
            end
        end
        result = [result v]
    end
    return result
end


function nullspacex(A::AbstractMatrix{T}) where {T<:IntegerX}
    return nullspacex(big.(A) // 1)
end

function nullspacex(A::AbstractMatrix{T}) where {T<:AbstractAlgebraicFunction}
    A = SimpleRationalFunction.(A)
    return _nullspacex(A)
end

"""
    nullityx(A::AbstractMatrix{T})::Int where {T}

Return the nullity of the matrix `A`.
"""
function nullityx(A::AbstractMatrix{T})::Int where {T}
    NS = nullspacex(A)
    r, c = size(NS)
    return c
end
export nullityx

export char_poly

"""
    char_poly(A::AbstractMatrix{T}) where {T<:TypeX}

`char_poly(A)` returns the characteristic polynomial of
the exact matrix `A`.
"""
function char_poly(A::AbstractMatrix{T}) where {T<:TypeX}
    r, c = size(A)
    @assert r == c "Matrix must be square"

    xI = zeros(SimplePolynomial, r, r)
    x = getx(T)
    for i = 1:r
        xI[i, i] = x
    end

    f = detx(xI - A)
    p = integerize(numerator(f))
end

using Mods, Primes, SimpleGraphs, LinearAlgebraX

"""
`generate_points(p::Int)` generates the homogeneous coordinates of the 
points in a finite projective plane of prime order `p`.
"""
function generate_points(p::Integer)::Vector{HVector}
    if ~isprime(p)
        error("Modulus $p is not prime")
    end

    n = p * p + p + 1
    A = Array{HVector}(undef, n)
    count = 1

    # case c=1
    for a = 0:p-1
        for b = 0:p-1
            x = Mod{p}.([a, b, 1])
            A[count] = HVector(x)
            count += 1
        end
    end

    # case c=0, b=1
    for a = 0:p-1
        x = Mod{p}.([a, 1, 0])
        A[count] = HVector(x)
        count += 1
    end

    A[count] = HVector(Mod{p}(1), 0, 0)

    return A
end

"""
`incidence_matrix(p::Int)` creates the point/line incidence matrix 
of a finite projective plane of prime order `p`.
"""
function incidence_matrix(p::Int)::Matrix
    pts = generate_points(p)
    n = p * p + p + 1
    A = zeros(Int, n, n)
    for u = 1:n
        P = pts[u]
        for v = 1:n
            Q = pts[v]
            if dot(P, Q) == 0
                A[u, v] = 1
            end
        end
    end
    return A
end

"""
`incidence_graph(p::Int)` creates the bipartite point-line 
incidence graph of a finite projective plane of prime order `p`.
"""
function incidence_graph(p::Int)::UndirectedGraph{Int}
    M = incidence_matrix(p)
    r, c = size(M)
    A = [zeros(r, c) M; copy(M') zeros(r, c)]
    G = UndirectedGraph(A)
end

function incidence_hypergraph(p::Int)::HyperGraph
    VV = generate_points(p)
    H = HyperGraph{HVector{Mod{p,Int}}}()
    for v in VV
        add!(H, v)
    end

    for v in VV
        S = [w for w in VV if dot(v, w) == 0]
        add!(H, Set(S))
    end

    return H
end

using Primes
export smith_normal_form

abstract type AbstractMatrixOperation{R} end
abstract type AbstractRowOperation{R} <: AbstractMatrixOperation{R} end
abstract type AbstractColumnOperation{R} <: AbstractMatrixOperation{R} end
struct RowSwap{R} <: AbstractRowOperation{R}
    i::Int
    j::Int
end
struct RowAddMult{R} <: AbstractRowOperation{R}
    i::Int
    j::Int
    c::R
end
struct RowScale{R} <: AbstractRowOperation{R}
    i::Int
    u::R
end
struct RowSmith{R} <: AbstractRowOperation{R}
    i::Int
    j::Int
    s::R
    u::R
    t::R
    v::R
end
struct ColumnSwap{R} <: AbstractColumnOperation{R}
    i::Int
    j::Int
end
struct ColumnAddMult{R} <: AbstractColumnOperation{R}
    i::Int
    j::Int
    c::R
end
struct ColumnScale{R} <: AbstractColumnOperation{R}
    i::Int
    u::R
end
struct ColumnSmith{R} <: AbstractColumnOperation{R}
    i::Int
    j::Int
    s::R
    u::R
    t::R
    v::R
end

detx(op::RowSwap{R}) where {R} = (op.i == op.j) ? one(R) : -one(R)
detx(::RowAddMult{R}) where {R} = one(R)
detx(op::RowScale{R}) where {R} = op.u
detx(op::RowSmith{R}) where {R} = op.s * op.v - op.u * op.t
detx(op::ColumnSwap{R}) where {R} = (op.i == op.j) ? one(R) : -one(R)
detx(::ColumnAddMult{R}) where {R} = one(R)
detx(op::ColumnScale{R}) where {R} = op.u
detx(op::ColumnSmith{R}) where {R} = op.s * op.v - op.u * op.t

(r::AbstractMatrixOperation{R})(M::AbstractMatrix{R}) where {R} =
    apply_matrix_operation!(M, r)

function apply_matrix_operation!(M::AbstractMatrix{R}, op::RowSwap{R}) where {R}
    M[op.i, :], M[op.j, :] = M[op.j, :], M[op.i, :]
    return M
end
function apply_matrix_operation!(M::AbstractMatrix{R}, op::RowAddMult{R}) where {R}
    M[op.j, :] += op.c * M[op.i, :]
    return M
end
function apply_matrix_operation!(M::AbstractMatrix{R}, op::RowScale{R}) where {R}
    M[op.i, :] *= op.u
    return M
end
function apply_matrix_operation!(M::AbstractMatrix{R}, op::RowSmith{R}) where {R}
    M[[op.i, op.j], :] = [op.s op.t; op.u op.v] * M[[op.i, op.j], :]
    return M
end
function apply_matrix_operation!(M::AbstractMatrix{R}, op::ColumnSwap{R}) where {R}
    M[:, op.i], M[:, op.j] = M[:, op.j], M[:, op.i]
    return M
end
function apply_matrix_operation!(M::AbstractMatrix{R}, op::ColumnAddMult{R}) where {R}
    M[:, op.j] += op.c * M[:, op.i]
    return M
end
function apply_matrix_operation!(M::AbstractMatrix{R}, op::ColumnScale{R}) where {R}
    M[:, op.i] *= op.u
    return M
end
function apply_matrix_operation!(M::AbstractMatrix{R}, op::ColumnSmith{R}) where {R}
    M[:, [op.i, op.j]] = M[:, [op.i, op.j]] * [op.s op.u; op.t op.v]
    return M
end

"""
smith_coeff(a::Mod{N, T}, b::Mod{N, T}[, prime_powers]) where {N, T}

Return a invertable matrix `M` such that `M*[a; b] = [g; 0]`, 
where `g` is a gcd of `a` and `b`.
"""
function smith_coeff(
    a::Mod{N,T},
    b::Mod{N,T},
    prime_powers::Union{Nothing,Vector{<:Integer}} = nothing,
) where {N,T}
    prime_powers = isnothing(prime_powers) ? [p^d for (p, d) in factor(N)] : prime_powers
    return smith_coeff(T, value(a), value(b), prime_powers, N)
end

function smith_coeff(T, a::Integer, b::Integer, prime_powers::Vector{<:Integer}, N::Integer)
    as = a .% prime_powers
    bs = b .% prime_powers
    zas = iszero.(as)
    zbs = iszero.(bs)
    za = Mod{N,T}(CRT(BigInt, zas, prime_powers))
    zb = Mod{N,T}(CRT(BigInt, zbs, prime_powers))
    zabs = zas .* zbs
    as = as + zas .* bs
    bs = bs + zbs .* as
    pas = gcd.(as, prime_powers)
    pbs = gcd.(bs, prime_powers)
    cas = as .÷ pas
    cbs = bs .÷ pbs
    pas = pas .* ((!).(zabs))
    pbs = pbs .* ((!).(zabs))
    cas = cas + zabs
    cbs = cbs + zabs
    @assert cas .* pas == as
    @assert cbs .* pbs == bs
    ca = Mod{N,T}(CRT(BigInt, cas, prime_powers))
    cb = Mod{N,T}(CRT(BigInt, cbs, prime_powers))
    αs = pbs .÷ (pas + zabs)
    βs = pas .÷ (pbs + zabs)
    γs = iszero.(αs)
    α = Mod{N,T}(CRT(BigInt, αs, prime_powers))
    β = Mod{N,T}(CRT(BigInt, βs, prime_powers))
    γ = Mod{N,T}(CRT(BigInt, γs, prime_powers))
    M_za = Mod{N,T}[1 za; 0 1]
    M_zb = Mod{N,T}[1 0; zb 1]
    M_inv_ca_cb = Mod{N,T}[inv(ca) 0; 0 inv(cb)]
    M_α = Mod{N,T}[1 0; -α 1]
    M_β = Mod{N,T}[1 -β; 0 1]
    M_plus_γ = Mod{N,T}[1 γ; 0 1]
    M_minus_γ = Mod{N,T}[1 -γ; 0 1]
    M = M_minus_γ * M_plus_γ * M_β * M_α * M_inv_ca_cb * M_zb * M_za
    res = Mod{N,T}[a; b]
    res = M * res
    @assert iszero(res[2])
    return M
end

"""
    divisible(a::Mod{N, T}, b::Mod{N, T}[, prime_powers]) where {N, T}

Check if a | b mod N, where N is the product of `prime_powers`.
"""
function divisible(
    a::Mod{N,T},
    b::Mod{N,T},
    prime_powers::Union{Nothing,Vector{<:Integer}} = nothing,
) where {N,T}
    prime_powers = isnothing(prime_powers) ? [p^d for (p, d) in factor(N)] : prime_powers
    _, r = mod_divrem(T, value(b), value(a), prime_powers, N)
    return iszero(r)
end

function Base.divrem(
    a::Mod{N,T},
    b::Mod{N,T},
    prime_powers::Union{Nothing,Vector{<:Integer}} = nothing,
) where {N,T}
    prime_powers = isnothing(prime_powers) ? [p^d for (p, d) in factor(N)] : prime_powers
    return mod_divrem(T, value(a), value(b), prime_powers, N)
end

function mod_divrem(T, a::Integer, b::Integer, prime_powers::Vector{<:Integer}, N::Integer)
    as = a .% prime_powers
    bs = b .% prime_powers
    pas = gcd.(as, prime_powers)
    pbs = gcd.(bs, prime_powers)

    # `a` is not divisible by `b`.
    !all(iszero, rem.(pas, pbs)) && return Mod{N,T}(0), Mod{N,T}(a)

    # `a` is divisible by `b`: `a = b * c`.
    zbs = iszero.(bs)
    αs = as .÷ pas
    βs = bs .÷ pbs + zbs
    inv_βs = [gcdx(β, p)[2] for (β, p) in zip(βs, prime_powers)]
    cs = inv_βs .* αs .* (pas .÷ pbs)
    cs[zbs] .= 0
    # @assert all(rem.(ds, prime_powers) .== 0)
    c = Mod{N,T}(CRT(BigInt, cs, prime_powers))
    return c, Mod{N,T}(0)
end

"""
    smith_normal_form(M::Matrix{Mod{N, T}}[, prime_powers]) where {N, T}

Compute the Smith normal form of `M` over `Z_N`. It returns matrices `S`, `U`, and `V` 
such that `S = U * M * V` and `S` is in Smith normal form of `M`.
"""
function smith_normal_form(
    M::AbstractMatrix{Mod{N,T}},
    prime_powers::Union{Nothing,Vector{<:Integer}} = nothing,
) where {N,T}
    m, n = size(M)
    S, row_ops, col_ops = smith_normal_form!(copy(M), prime_powers)
    U = eye(Mod{N,T}, m)
    V = eye(Mod{N,T}, n)
    for op in row_ops
        op(U)
    end
    for op in col_ops
        op(V)
    end
    return S, U, V
end

function smith_normal_form!(
    M::AbstractMatrix{Mod{N,T}},
    prime_powers::Union{Nothing,Vector{<:Integer}} = nothing,
) where {N,T}
    prime_powers = isnothing(prime_powers) ? [p^d for (p, d) in factor(N)] : prime_powers
    R = Mod{N,T}
    m, n = size(M)
    row_ops = AbstractMatrixOperation{R}[]
    col_ops = AbstractMatrixOperation{R}[]
    for i = 1:min(m, n)
        smith_elimination!(M, row_ops, col_ops, i, prime_powers)
    end
    diag_normalized = false
    while diag_normalized
        diag_normalized = true
        for i = 2:min(m, n)
            if !divisible(M[i-1, i-1], M[i, i])
                diag_normalized = false
                op = ColumnAddMult(i, i - 1, one(R))
                push!(col_ops, op)
                op(M)
                smith_elimination!(M, row_ops, col_ops, i - 1, prime_powers)
                break
            end
        end
    end
    return M, row_ops, col_ops
end

function smith_elimination!(
    M::AbstractMatrix{Mod{N,T}},
    row_ops,
    col_ops,
    i,
    prime_powers::Vector{<:Integer},
) where {N,T}
    R = Mod{N,T}
    m, n = size(M)
    @assert 1 <= i <= min(m, n)
    finished = false
    while !finished
        finished = true

        # Eliminate the i-th column.
        if iszero(M[i, i])
            for j = i+1:m
                if !iszero(M[j, i])
                    op = RowSwap{R}(i, j)
                    push!(row_ops, op)
                    op(M)
                    break
                end
            end
        end
        for j = i+1:m
            c, r = divrem(M[j, i], M[i, i])
            if iszero(r)
                op = RowAddMult{R}(i, j, -c)
                push!(row_ops, op)
                op(M)
            else
                op = RowSmith{R}(i, j, smith_coeff(M[i, i], M[j, i], prime_powers)[:]...)
                push!(row_ops, op)
                op(M)
                finished = false
            end
        end

        # Eliminate the i-th row.
        if iszero(M[i, i])
            for j = i+1:n
                if !iszero(M[i, j])
                    op = ColumnSwap{R}(i, j)
                    push!(col_ops, op)
                    op(M)
                    break
                end
            end
        end
        for j = i+1:n
            c, r = divrem(M[i, j], M[i, i])
            if iszero(r)
                op = ColumnAddMult{R}(i, j, -c)
                push!(col_ops, op)
                op(M)
            else
                op = ColumnSmith{R}(i, j, smith_coeff(M[i, i], M[i, j], prime_powers)[:]...)
                push!(col_ops, op)
                op(M)
                finished = false
            end
        end
    end
    return M, row_ops, col_ops
end

using Permutations

"""
    old_permanent(A::AbstractMatrix{T}) where {T<:Union{IntegerX,RationalX}}

Compute the permanent of a matrix by iterating over all permutations. Very slow. 
"""
function old_permanent(A::AbstractMatrix{T}) where {T<:Union{IntegerX,RationalX}}
    A = big.(A)
    return perm_work(A)
end

function old_permanent(A::AbstractMatrix{T})::T where {T}
    perm_work(A)
end

function perm_work(A::AbstractMatrix{T}) where {T}
    r, c = size(A)
    if r != c
        error("Matrix must be square")
    end
    if r == 0
        return zero(T)
    end

    allow = [findall((x) -> x != 0, A[i, :]) for i = 1:r]
    PG = PermGen(allow)

    try
        first(PG)  # make sure PG is not empty
        return sum(prod(A[i, p[i]] for i = 1:r) for p in PG)
    catch
        return zero(T)
    end
end

export cofactor_det

"""
    cofactor_det(A::AbstractMatrix{T}) where {T}

`cofactor(A::AbstractMatrix{T})` computes the determinant of `A` using
cofactor expansion (which can be slow).
The return type of this method is a number of type `T`.
The entries in `A` can be polynomials and that won't work with
Julia's `det`.
"""
function cofactor_det(A::AbstractMatrix{T}) where {T}
    r, c = size(A)
    @assert r == c "Matrix must be square"
    @assert r > 0 "Matrix cannot be 0-by-0"
    if r == 1
        return A[1, 1]
    end

    total = 0 * A[1, 1]
    sign = -1
    for i = 1:r
        a = A[i, 1]
        sign = -sign
        if a == 0
            continue
        end
        ii = vcat(1:i-1, i+1:r)
        jj = 2:r
        B = A[ii, jj]
        total += sign * a * cofactor_det(B)
    end

    return total
end

export upper_triangular, lower_triangular

function upper_triangular(
    M::AbstractMatrix{Mod{N,T}},
    prime_powers::Union{Nothing,Vector{<:Integer}} = nothing,
) where {N,T}
    U = copy(M)
    U, row_ops = upper_triangular!(U, prime_powers)
    C = eye(Mod{N,T}, size(U, 1))
    for op in row_ops
        apply_matrix_operation!(C, op)
    end
    return U, C
end

function upper_triangular!(
    M::AbstractMatrix{Mod{N,T}},
    prime_powers::Union{Nothing,Vector{<:Integer}} = nothing,
) where {N,T}
    prime_powers = isnothing(prime_powers) ? [p^d for (p, d) in factor(N)] : prime_powers
    R = Mod{N,T}
    ops = AbstractMatrixOperation{R}[]
    m, n = size(M)
    for i = 1:min(m, n)
        # Find a non-zero element in the i-th column.
        if iszero(M[i, i])
            for j = i+1:m
                if !iszero(M[j, i])
                    op = RowSwap{R}(i, j)
                    push!(ops, op)
                    apply_matrix_operation!(M, op)
                    break
                end
            end
        end
        # Make U[i,j] = 0 for j = i+1:n.
        for j = i+1:m
            if !iszero(M[j, i])
                c, r = divrem(M[j, i], M[i, i], prime_powers)
                op = if iszero(r)
                    RowAddMult{R}(i, j, -c)
                else
                    RowSmith{R}(i, j, smith_coeff(M[i, i], M[j, i], prime_powers)[:]...)
                end
                push!(ops, op)
                apply_matrix_operation!(M, op)
            end
        end
    end
    return M, ops
end

function lower_triangular(
    M::AbstractMatrix{Mod{N,T}},
    prime_powers::Union{Nothing,Vector{<:Integer}} = nothing,
) where {N,T}
    L = copy(M)
    L, col_ops = lower_triangular!(L, prime_powers)
    C = eye(Mod{N,T}, size(L, 2))
    for op in col_ops
        apply_matrix_operation!(C, op)
    end
    return L, C
end
function lower_triangular!(
    M::AbstractMatrix{Mod{N,T}},
    prime_powers::Union{Nothing,Vector{<:Integer}} = nothing,
) where {N,T}
    prime_powers = isnothing(prime_powers) ? [p^d for (p, d) in factor(N)] : prime_powers
    R = Mod{N,T}
    ops = AbstractMatrixOperation{R}[]
    m, n = size(M)
    for i = 1:min(m, n)
        # Find a non-zero element in the -th row.
        if iszero(M[i, i])
            for j = i+1:n
                if !iszero(M[i, j])
                    op = ColumnSwap{R}(i, j)
                    push!(ops, op)
                    apply_matrix_operation!(M, op)
                    break
                end
            end
        end
        # Make U[i,j] = 0 for j = i+1:n.
        for j = i+1:n
            if !iszero(M[i, j])
                c, r = divrem(M[i, j], M[i, i], prime_powers)
                op = if iszero(r)
                    ColumnAddMult{R}(i, j, -c)
                else
                    ColumnSmith{R}(i, j, smith_coeff(M[i, i], M[i, j], prime_powers)[:]...)
                end
                push!(ops, op)
                apply_matrix_operation!(M, op)
            end
        end
    end
    return M, ops
end

# matrix (and other) inversion

export invx

"""
    invx(A::AbstractMatrix{T}) where {T}

`invx(A)` for a matrix `A` gives an exact matrix inverse.
"""
function invx(A::AbstractMatrix{T}) where {T<:Union{IntegerX,RationalX}}
    return inv(big.(A) // 1)
end

function invx(A::AbstractMatrix{T})::Matrix{T} where {T<:Mod}
    return inv(A)
end

function invx(
    A::AbstractMatrix{T},
)::Matrix{SimpleRationalFunction} where {T<:AbstractAlgebraicFunction}
    B = SimpleRationalFunction.(A)
    return _invx(B)
end


# for those types otherwise not specified
invx(A::AbstractMatrix{T}) where {T} = _invx(A)



function _invx(A::AbstractMatrix{T}) where {T}
    r, c = size(A)
    @assert r == c "Matrix must be square"

    if r == 0
        return A
    end

    B = eye(T, r)

    X = [A B]
    X = rrefx(X)

    d = [X[i, i] for i = 1:r]
    if all(d .== 1)
        return X[:, r+1:end]
    end
    @error "Matrix is not invertible"
end


function invx(x::T) where {T<:IntegerX}
    return 1 // x
end

invx(x) = 1 / x

import Base: show, eltype, length, size, getindex, ==, (*), iszero
import Base: Vector, Matrix, adjoint, hash

import LinearAlgebra: dot
export HVector, HMatrix, dot, hash


"""
An `HVector` is a homogeneous vector; two `HVector`s are equal 
iff they are nonzero multiples of each other.

`HVector(a,b,c,...)` or `HVector([a,b,c,...])` creates a new `HVector `
with coordinates `(a,b,c,...)`.
"""
struct HVector{T}
    data::Vector{T}
    function HVector(dat::Vector{T}) where {T}
        data = dat .// one(T)
        S = typeof(sum(data))
        new{S}(_canonical(data))
    end

end
HVector(x...) = HVector(collect(x))
HVector(x::HVector) = HVector(x.data)

"""
An `HMatrix` is a homogeneous matrix; two of these are equal if they are
nonzero multiples of each other. 

Given a two-dimensional array `A`, `HMatrix(A)` creates a new homogeneous 
matrix. 
"""
struct HMatrix{T}
    data::Matrix{T}
    function HMatrix(dat::AbstractMatrix{T}) where {T}
        data = dat .// one(T)
        S = typeof(sum(data))
        M = new{S}(_canonical(data))
        return M
    end
end
HMatrix(x::HMatrix) = HMatrix(x.data)


function _canonical(x)
    if length(x) == 0 || iszero(x)
        return x
    end
    idx = findlast(x .!= 0)
    a = x[idx]
    return x .// a
end

HObject = Union{HVector,HMatrix}


eltype(x::HObject) = eltype(x.data)
length(x::HObject) = length(x.data)
size(x::HObject) = size(x.data)
getindex(x::HObject, k...) = x.data[k...]
(==)(x::HObject, y::HObject) = x.data == y.data
iszero(x::HObject) = iszero(x.data)


"""
    dot(x::HVector, y::HVector)::Int

The `dot` produce of two `HVector`s is either `0` 
(if they are orthogonal) or `1` (otherwise).
"""
function dot(x::HVector, y::HVector)::Int
    d = dot(x.data, y.data)
    if d == 0
        return 0
    end
    return 1
end

# OLD VERSION
#
# function show(io::IO, x::HVector)
#     print(io, "HVector(")
#     n = length(x.data)
#     for j = 1:n-1
#         print(io, "$(x.data[j]), ")
#     end
#     print(io, x.data[end], ")")
# end

function show(io::IO, x::HVector)
    print(io, "[")
    n = length(x.data)
    for j = 1:n-1
        print(io, "$(x.data[j]) : ")
    end
    print(io, x.data[end], "]")
end





function show(io::IO, x::HMatrix)
    print(io, "HMatrix: ")
    print(io, x.data)
end

function (*)(A::AbstractArray{T,2}, v::HVector) where {T}
    Av = A * v.data
    return HVector(Av)
end

function (*)(A::AbstractArray{T,2}, B::HMatrix) where {T}
    AB = A * B.data
    return HMatrix(AB)
end

(*)(A::HMatrix, v::HVector) = HVector(A.data * v.data)
(*)(A::HMatrix, B::HMatrix) = HMatrix(A.data * B.data)

adjoint(A::HMatrix) = HMatrix(adjoint(A.data))

hash(x::HObject, h::UInt) = hash(x.data, h)

Vector(x::HVector) = copy(x.data)
Matrix(x::HMatrix) = copy(x.data)

export permanent

_enlarge(x::T) where {T<:Union{IntegerX,RationalX}} = big(x)
_enlarge(x) = x

"""
    permanent(A)

Compute the permanent of the square matrix `A`.
"""
function permanent(A::AbstractMatrix{T}) where {T}     # code by Daniel Scheinerman
    A = _enlarge.(A)
    m, n = size(A)
    s = _enlarge(zero(T)) #to accumulate the permanent
    x = UInt64(0) #gray code state
    v = zeros(Int64, n) #current subset sum
    for i = 1:2^n-1
        t = trailing_zeros(i) #next bit flip
        b = (x >> t) & 1 #if 1 then add row, else subtract
        x = xor(x, 1 << t)
        if b == 0
            v += A[t+1, :]
        else
            v -= A[t+1, :]
        end
        s += (-1)^(i & 1) * prod(v)
    end
    s *= (-1)^n
    return s
end

# LinearAlgebraX

This module implements basic linear algebra methods for matrices
with exact entries (e.g., `Rational{Int}` values).  The function names
typically match the standard ones in Julia but with an `x` (for "exact")
appended.

The functions in this module work for all types of 
`Integer`, `Rational`, `Complex{Integer}`, `Complex{Rational}`, and `Mod`
entries in matrices. Other exact numbers may work as well, but are not tested. 

As the goal of this module is always to give exact answers and, at the same time,
be type stable, the results of many of these functions are `big`. That is, the `detx`
of an integer matrix returns a `BigInt`. 

## Functions

These functions in this module end with the letter `x`
and have the same definitions as their counterparts that do not have an `x`.
For exact types (such as `Int`s) these functions give exact results.

* `detx` -- exact determinant 
* `cofactor_det`-- slower exact determinant (via cofactor expansion)
* `nullspacex` -- exact nullspace
* `rankx` -- exact rank
* `invx` -- exact inverse
* `rrefx` -- row reduced echelon form
* `eye` -- lovingly restored
* `char_poly` -- characteristic polynomial
* `permanent` -- permanent of a square matrix

Examples follow.

## Determinant

```
julia> A = ones(Int,10,10)+eye(Int,10);

julia> det(A)
10.999999999999998

julia> detx(A)
11

julia> A = rand(Int,20,20) .% 20;

julia> det(A)
3.3905496651565455e29

julia> detx(A)
339054966515654744413389494504
```

For certain `Mod` matrices, there may be noninvertible nonzero elements in which 
case the Gaussian elimination algorithm may fail. If that happens, `detx` 
falls back to using cofactor expansion which may be very slow. Should that 
happen, a warning is generated.
```
julia> using Mods

julia> A = rand(Mod{10},5,5)
5×5 Array{Mod{10},2}:
 Mod{10}(6)  Mod{10}(1)  Mod{10}(8)  Mod{10}(7)  Mod{10}(9)
 Mod{10}(6)  Mod{10}(4)  Mod{10}(6)  Mod{10}(9)  Mod{10}(0)
 Mod{10}(9)  Mod{10}(8)  Mod{10}(7)  Mod{10}(8)  Mod{10}(0)
 Mod{10}(9)  Mod{10}(1)  Mod{10}(9)  Mod{10}(1)  Mod{10}(3)
 Mod{10}(5)  Mod{10}(4)  Mod{10}(5)  Mod{10}(9)  Mod{10}(0)

julia> detx(A)
┌ Warning: Using cofactor expansion to calculate determinant; may be very slow.
└ @ LinearAlgebraX ~/.julia/dev/LinearAlgebraX/src/detx.jl:41
Mod{10}(4)
```




## Nullspace

```
julia> A = reshape(collect(1:12),3,4)
3×4 Array{Int64,2}:
 1  4  7  10
 2  5  8  11
 3  6  9  12

julia> nullspacex(A)
4×2 Array{Rational{BigInt},2}:
  1//1   2//1
 -2//1  -3//1
  1//1   0//1
  0//1   1//1

julia> nullspace(A)
4×2 Array{Float64,2}:
 -0.475185  -0.272395
  0.430549   0.717376
  0.564458  -0.617566
 -0.519821   0.172585
```

## Rank

Consider the 12-by-12 Hibert matrix, `H` (see `hilbert.jl` in the `extras` folder):
```
12×12 Array{Rational{Int64},2}:
 1//1   1//2   1//3   1//4   1//5   1//6   1//7   1//8   1//9   1//10  1//11  1//12
 1//2   1//3   1//4   1//5   1//6   1//7   1//8   1//9   1//10  1//11  1//12  1//13
 1//3   1//4   1//5   1//6   1//7   1//8   1//9   1//10  1//11  1//12  1//13  1//14
 1//4   1//5   1//6   1//7   1//8   1//9   1//10  1//11  1//12  1//13  1//14  1//15
 1//5   1//6   1//7   1//8   1//9   1//10  1//11  1//12  1//13  1//14  1//15  1//16
 1//6   1//7   1//8   1//9   1//10  1//11  1//12  1//13  1//14  1//15  1//16  1//17
 1//7   1//8   1//9   1//10  1//11  1//12  1//13  1//14  1//15  1//16  1//17  1//18
 1//8   1//9   1//10  1//11  1//12  1//13  1//14  1//15  1//16  1//17  1//18  1//19
 1//9   1//10  1//11  1//12  1//13  1//14  1//15  1//16  1//17  1//18  1//19  1//20
 1//10  1//11  1//12  1//13  1//14  1//15  1//16  1//17  1//18  1//19  1//20  1//21
 1//11  1//12  1//13  1//14  1//15  1//16  1//17  1//18  1//19  1//20  1//21  1//22
 1//12  1//13  1//14  1//15  1//16  1//17  1//18  1//19  1//20  1//21  1//22  1//23
```
We compare the results of `rank` (from the `LinearAlgebra` module) and
`rankx` (in this module):
```
julia> rank(H)
11

julia> rankx(H)
12
```

## Inverse

```
julia> using Mods

julia> A = rand(Mod{11},5,5)
5×5 Array{Mod{11},2}:
 Mod{11}(2)   Mod{11}(4)  Mod{11}(4)  Mod{11}(0)   Mod{11}(2)
 Mod{11}(9)   Mod{11}(4)  Mod{11}(5)  Mod{11}(1)  Mod{11}(10)
 Mod{11}(3)   Mod{11}(4)  Mod{11}(5)  Mod{11}(6)   Mod{11}(0)
 Mod{11}(5)  Mod{11}(10)  Mod{11}(4)  Mod{11}(5)   Mod{11}(4)
 Mod{11}(9)  Mod{11}(10)  Mod{11}(7)  Mod{11}(8)   Mod{11}(9)

julia> B = invx(A)
5×5 Array{Mod{11},2}:
 Mod{11}(4)  Mod{11}(5)  Mod{11}(0)   Mod{11}(6)   Mod{11}(8)
 Mod{11}(7)  Mod{11}(4)  Mod{11}(9)  Mod{11}(10)   Mod{11}(3)
 Mod{11}(6)  Mod{11}(0)  Mod{11}(2)   Mod{11}(5)   Mod{11}(5)
 Mod{11}(3)  Mod{11}(4)  Mod{11}(9)  Mod{11}(10)  Mod{11}(10)
 Mod{11}(9)  Mod{11}(9)  Mod{11}(0)   Mod{11}(8)   Mod{11}(9)

julia> A*B
5×5 Array{Mod{11},2}:
 Mod{11}(1)  Mod{11}(0)  Mod{11}(0)  Mod{11}(0)  Mod{11}(0)
 Mod{11}(0)  Mod{11}(1)  Mod{11}(0)  Mod{11}(0)  Mod{11}(0)
 Mod{11}(0)  Mod{11}(0)  Mod{11}(1)  Mod{11}(0)  Mod{11}(0)
 Mod{11}(0)  Mod{11}(0)  Mod{11}(0)  Mod{11}(1)  Mod{11}(0)
 Mod{11}(0)  Mod{11}(0)  Mod{11}(0)  Mod{11}(0)  Mod{11}(1)
```

 ## Characteristic polynomial

```
julia> using SimplePolynomials, LinearAlgebra

julia> x = getx()
x

julia> A = triu(ones(Int,5,5))
5×5 Array{Int64,2}:
 1  1  1  1  1
 0  1  1  1  1
 0  0  1  1  1
 0  0  0  1  1
 0  0  0  0  1

julia> char_poly(A)
-1 + 5*x - 10*x^2 + 10*x^3 - 5*x^4 + x^5

julia> ans == (x-1)^5
true

julia> using Mods

julia> A = rand(Mod{17},4,4)
4×4 Array{Mod{17},2}:
 Mod{17}(16)  Mod{17}(10)   Mod{17}(9)  Mod{17}(12)
 Mod{17}(15)   Mod{17}(1)   Mod{17}(1)   Mod{17}(6)
  Mod{17}(3)   Mod{17}(2)   Mod{17}(5)  Mod{17}(11)
  Mod{17}(5)  Mod{17}(15)  Mod{17}(15)   Mod{17}(7)

julia> char_poly(A)
Mod{17}(1) + Mod{17}(1)*x + Mod{17}(16)*x^2 + Mod{17}(5)*x^3 + Mod{17}(1)*x^4

julia> detx(A)
Mod{17}(1)
```

 ## Row reduced echelon form

 ```
 julia> A = rand(Int,4,6) .% 10
4×6 Array{Int64,2}:
 6   8  0  -6  -5   4
 0  -5  2   0  -3  -4
 0  -4  2  -8   7  -8
 1  -3  7   2  -6   2

julia> c = A[:,1] + A[:,2] - A[:,3]
4-element Array{Int64,1}:
 14
 -7
 -6
 -9

julia> A = [c A]
4×7 Array{Int64,2}:
 14  6   8  0  -6  -5   4
 -7  0  -5  2   0  -3  -4
 -6  0  -4  2  -8   7  -8
 -9  1  -3  7   2  -6   2

julia> rrefx(A)
4×7 Array{Rational{Int64},2}:
 1//1  0//1  0//1  -1//1  0//1   -23//130  -36//65
 0//1  1//1  0//1   1//1  0//1  -883//325  158//325
 0//1  0//1  1//1   1//1  0//1   551//650  512//325
 0//1  0//1  0//1   0//1  1//1  -379//325  204//325
```

 ##  Homogeneous Vectors

 A point in projective space is represented by a *homogeneous vector*. This is 
 a list of numbers (like an ordinary vector) but two such vectors are equal 
 if and only if one is a nonzero multiple of the other. 

 We provide the `HVector` type to represent homogeneous vectors. The entries 
 in an `HVector` are scaled so that the last nonzero coordinate is `1`. 
 (Technically, we should forbid the all zero vector, but we don't implement
 that restriction.)

 To create an `HVector` provide either a list (one-dimensional array) of values 
 or a list of arguments:
 ```
 julia> v = HVector([1,-2,3])
[1//3 : -2//3 : 1//1]

julia> w = HVector(2,-4,6)
[1//3 : -2//3 : 1//1]

julia> v==w
true
```

Entries in an `HVector` can be retrieved individually, or the entire vector can 
be converted to an array:
```
julia> v[2]
-2//3

julia> Vector(v)
3-element Array{Rational{Int64},1}:
  1//3
 -2//3
  1//1
```
However, entries cannot be assigned:
```
julia> v[2] = 3//4
ERROR: MethodError: no method matching setindex!(::HVector{Rational{Int64}}, ::Rational{Int64}, ::Int64)
```

### Operations for `HVector`s

The product of a matrix and a homogeneous vector is a homogeneous vector:
```
julia> A = rand(Int,3,3) .% 5
3×3 Array{Int64,2}:
 -1   0   0
  3   0  -2
  3  -1  -2

julia> A*v
[1//1 : 3//1 : 1//1]

julia> A*Vector(v)
3-element Array{Rational{Int64},1}:
 -1//3
 -1//1
 -1//3
```

The dot product of two homogeneous vectors is a scalar. Since homogeneous vectors
are unchanged by scaling, we only distinguish between zero and nonzero results.
Specifically, the dot product is `0` if the two vectors are orthogonal and 
`1` otherwise. 
```
julia> using Mods

julia> u = Mod{3}(1)
Mod{3}(1)

julia> v = HVector(u,u,u)
[Mod{3}(1) : Mod{3}(1) : Mod{3}(1)]

julia> dot(v,v)
0

julia> w = HVector(-1,2,1)
[-1//1 : 2//1 : 1//1]

julia> dot(v,w)
1
```


## Homogeneous Matrices

We also provide `HMatrix` to represent a homogeneous matrix. These are 
constructed by passing an (ordinary) matrix.
```
julia> A = rand(Int,3,3).%5
3×3 Array{Int64,2}:
 0  -4   3
 1   4  -2
 3   0  -3

julia> HMatrix(A)
HMatrix: Rational{Int64}[0//1 4//3 -1//1; -1//3 -4//3 2//3; -1//1 0//1 1//1]

julia> Matrix(ans)
3×3 Array{Rational{Int64},2}:
  0//1   4//3  -1//1
 -1//3  -4//3   2//3
 -1//1   0//1   1//1
```
 
